# TEST PROGRAM FOR SIMPLECPU_V1a1

# INSTR   IR15 IR14 IR13 IR12 IR11 IR10 IR09 IR08 IR07 IR06 IR05 IR04 IR03 IR02 IR01 IR00
# MOVE    0    0    0    0    X    X    X    X    K    K    K    K    K    K    K    K
# ADD     0    0    0    1    X    X    X    X    K    K    K    K    K    K    K    K
# SUB     0    0    1    0    X    X    X    X    K    K    K    K    K    K    K    K
# AND     0    0    1    1    X    X    X    X    K    K    K    K    K    K    K    K

# LOAD    0    1    0    0    X    X    X    X    A    A    A    A    A    A    A    A
# STORE   0    1    0    1    X    X    X    X    A    A    A    A    A    A    A    A
# ADDM    0    1    1    0    X    X    X    X    A    A    A    A    A    A    A    A
# SUBM    0    1    1    1    X    X    X    X    A    A    A    A    A    A    A    A

# JUMPU   1    0    0    0    X    X    X    X    A    A    A    A    A    A    A    A
# JUMPZ   1    0    0    1    X    X    X    X    A    A    A    A    A    A    A    A
# JUMPNZ  1    0    1    0    X    X    X    X    A    A    A    A    A    A    A    A

# JUMPC   1    0    1    1    X    X    X    X    A    A    A    A    A    A    A    A 
# ROTR    1    1    0    0    X    X    X    X    X    X    X    X    X    X    X    X

#
# MAIN PROGRAM
#

start:
    move 8
    store CNT       # number of bits in multiplier

    move 255        # set multiplier
    store X
    move 0          # zero initial partial product
    store Y
    move 255        # set multiplicand
    store Z

loop:
    move 0          # clear carry flag
    add 0           # not needed, but just in case ADDER is updated to use CIN

    load Z          # test multiplier LSB
    and 1
    jumpz shiftY    # if zero shift

    load Y          # if one add multiplicand
    addm X
    rotr            # rotate Y    
    store Y    
    jump shiftZ
    
shiftY:         
    load Y          # rotate Y
    rotr
    store Y   
shiftZ:
    load Z          # rotate Z          
    rotr
    store Z

dec:
    load CNT        # decrement and test loop count
    sub 1
    store CNT
    jumpnz loop

finish:
  load Y            # read result
  load Z
  jump finish

CNT:
    .data 0
X: 
    .data 0
Y:
    .data 0
Z:
    .data 0




