-- TestBench Template 

  LIBRARY ieee;
  USE ieee.std_logic_1164.ALL;
  USE ieee.numeric_std.ALL;

  ENTITY testbench IS
  END testbench;

  ARCHITECTURE behavior OF testbench IS 

    -- Component Declaration
    COMPONENT computer
    PORT(
      CLK : in    std_logic; 
      CLR : in    std_logic; 
      RX  : in    std_logic; 
      GPO : out   std_logic_vector (7 downto 0); 
      TP0 : out   std_logic; 
      TX  : out   std_logic);
    END COMPONENT;

    SIGNAL clk : std_logic;
    SIGNAL clr : std_logic;
    SIGNAL rx  : std_logic;
    SIGNAL tx  : std_logic;	 
    SIGNAL tp0 : std_logic;
    SIGNAL gpo : std_logic_vector (7 downto 0); 	 	 

  BEGIN

    -- Component Instantiation
    uut: computer PORT MAP(
      CLK => clk,
      CLR => clr, 
      RX  => rx,
      TX  => tx,		
      GPO => gpo,
      TP0 => tp0);

    clock : PROCESS
    BEGIN
	   clk <= '0';
		wait for 5 ns;
	   clk <= '1';
		wait for 5 ns;		
    END PROCESS clock;
	 
    reset : PROCESS
    BEGIN
	   clr <= '1';
		wait for 200 ns;
	   clr <= '0';
		wait;		
    END PROCESS reset;	 
	 
    tb : PROCESS
    BEGIN
	   RX <= '1';
		wait;		
    END PROCESS tb;		 

  END;
